/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.kintai.common.part;

import java.util.List;
import java.util.Locale;

import jp.mosp.common.CommonConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.part.BasePart;
import jp.mosp.common.part.PartInfo;
import jp.mosp.common.utils.VariousUtil;
import jp.mosp.kintai.report.dao.CmOutPutDao;
import jp.mosp.kintai.report.dao.ExportDataDao;
import jp.mosp.kintai.report.dao.MExportColumnDao;
import jp.mosp.kintai.report.dao.MExportDao;
import jp.mosp.kintai.report.dto.MExportColumnDto;

/**
 * エクスポートに関するPartクラス
 * @author yoshida
 *	@version	0.0.2
 */
public class ExportPart extends BasePart {
	
	/**
	 * コンストラクタ
	 */
	public ExportPart() {
		super();
	}
	
	/**
	 * コンストラクタ
	 * @param partInfo 	Partを利用する際に必要な情報
	 */
	public ExportPart(PartInfo partInfo) {
		super(partInfo);
	}
	

	/**
	 * MExportColumnDaoインスタンス
	 */
	private MExportColumnDao	exportColumnDao;
	/**
	 * MExportDaoインスタンス
	 */
	private MExportDao			exportDao;
	/**
	 * ExportDataDaoインスタンス
	 */
	private ExportDataDao		exportDataDao;
	/**
	 * CmOutPutDaoインスタンス
	 */
	private CmOutPutDao			outPutDao;
	

	/**
	 * 情報項目用DAOの取得
	 * @return exportColumnDao
	 * @throws MospException  MosP例外処理が発生した場合
	 */
	public MExportColumnDao getExportColumnDao() throws MospException {
		if (VariousUtil.isNull(exportColumnDao)) {
			exportColumnDao = (MExportColumnDao)getPreparedDao(MExportColumnDao.class.getCanonicalName());
		}
		return exportColumnDao;
	}
	
	/**
	 * M_EXPORTテーブル用DAO取得
	 * @return	初期化済みMExportDaoインスタンス
	 * @throws MospException MosP例外処理が発生した場合
	 */
	public MExportDao getMExportDao() throws MospException {
		if (VariousUtil.isNull(exportDao)) {
			exportDao = (MExportDao)getPreparedDao(MExportDao.class.getCanonicalName());
		}
		return exportDao;
	}
	
	/**
	 * エクスポート用DAO取得
	 * @return	初期化済みExportDataDaoインスタンス
	 * @throws MospException MosP例外処理が発生した場合
	 */
	public ExportDataDao getExportDataDao() throws MospException {
		if (VariousUtil.isNull(exportDataDao)) {
			exportDataDao = (ExportDataDao)getPreparedDao(ExportDataDao.class.getCanonicalName());
		}
		return exportDataDao;
	}
	
	/**
	 * 出力マスタ用DAO取得
	 * @return 初期化済みCmOutPutDaoインスタンス
	 * @throws MospException MosP例外処理が発生した場合
	 */
	public CmOutPutDao getCmOutPutDao() throws MospException {
		if (VariousUtil.isNull(outPutDao)) {
			outPutDao = (CmOutPutDao)getPreparedDao(CmOutPutDao.class.getCanonicalName());
		}
		return outPutDao;
	}
	
	/**
	 * エクスポート情報項目設定
	 * @param strFLID	対象テーブルコード
	 * @return	String[][]	エクスポート情報項目配列
	 * @throws Exception 例外処理が発生した場合
	 */
	public String[][] getKintaiDataItem(String strFLID) throws Exception {
		return getColumnDataItem(strFLID, getTableColumnInfo(HumanPart.BASIS_TABLE),
				getTableColumnInfo(KintaiCompilePart.KINTAI_TABLE),
				getTableColumnInfo(KintaiCommonPart.SYUKKINBO_TABLE), getTableColumnInfo(PaidHolidayPart.OLD_TABLE));
	}
	
	/**
	 * 情報項目用配列取得
	 * @param tableName		対象テーブル名
	 * @return	 情報項目用配列
	 * @throws Exception 例外処理が発生した場合
	 */
	public String[] getTableColumnInfo(String tableName) throws Exception {
		List<MExportColumnDto> list = getExportColumnDao().findForCondition(tableName);
		String[] aryColumnInfo = new String[list.size()];
		int i = 0;
		for (MExportColumnDto dto : list) {
			StringBuffer sb = new StringBuffer();
			sb.append(tableName.toUpperCase(Locale.JAPANESE));
			sb.append(CommonConst.STR_UNDER_SEPARATOR);
			sb.append(i + 1);
			sb.append(CommonConst.STR_UNDER_SEPARATOR);
			sb.append(dto.getColumnField().toUpperCase(Locale.JAPANESE));
			sb.append(CommonConst.STR_UNDER_SEPARATOR);
			sb.append(dto.getColumnComment());
			aryColumnInfo[i] = sb.toString();
			i++;
		}
		return aryColumnInfo;
	}
	

	/**
	 * 人事情報取得用配列
	 */
	protected String[]	aryKihonItem;
	
	/**
	 * 勤怠情報項目用配列
	 */
	protected String[]	aryKintaiItem;
	
	/**
	 * 出勤簿情報項目用配列
	 */
	protected String[]	arySyukkinItem;
	
	/**
	 * 有給休暇情報項目用配列
	 */
	protected String[]	aryYukyuItem;
	

	/**
	 * エクスポート情報項目設定
	 * @param strFLID			対象テーブルコード
	 * @param aryKihonItem		人事情報取得用配列
	 * @param aryKintaiItem		勤怠情報項目用配列
	 * @param arySyukkinItem	出勤簿情報項目用配列
	 * @param aryYukyuItem		有給休暇情報項目用配列
	 * @return	String[][]		エクスポート情報項目配列
	 */
	public static String[][] getColumnDataItem(String strFLID, String[] aryKihonItem, String[] aryKintaiItem,
			String[] arySyukkinItem, String[] aryYukyuItem) {
		int itemLength = aryKihonItem.length;
		if (strFLID.equals(CommonConst.CODE_TABLE_M_KINTAI)) {
			itemLength += aryKintaiItem.length;
		}
		if (strFLID.equals(CommonConst.CODE_TABLE_M_SYUKKINBO)) {
			itemLength += arySyukkinItem.length;
		}
		if (strFLID.equals(CommonConst.CODE_TABLE_M_YUKYU)) {
			itemLength += aryYukyuItem.length;
		}
		int i = 0;
		String[][] aryItem = new String[itemLength][2];
		// 人事情報取得用配列
		for (i = 0; i < aryKihonItem.length; i++) {
			aryItem[i][0] = aryKihonItem[i];
			aryItem[i][1] = VariousUtil.getCsvSplitInfo(aryKihonItem[i], 3);
		}
		// 勤怠情報項目用配列
		int j = i;
		if (strFLID.equals(CommonConst.CODE_TABLE_M_KINTAI)) {
			for (i = 0; i < aryKintaiItem.length; i++) {
				aryItem[j + i][0] = aryKintaiItem[i];
				aryItem[j + i][1] = VariousUtil.getCsvSplitInfo(aryKintaiItem[i], 3);
			}
		}
		// 出勤簿情報項目用配列
		if (strFLID.equals(CommonConst.CODE_TABLE_M_SYUKKINBO)) {
			for (i = 0; i < arySyukkinItem.length; i++) {
				aryItem[j + i][0] = arySyukkinItem[i];
				aryItem[j + i][1] = VariousUtil.getCsvSplitInfo(arySyukkinItem[i], 3);
			}
		}
		// 有給休暇情報項目用配列
		if (strFLID.equals(CommonConst.CODE_TABLE_M_YUKYU)) {
			for (i = 0; i < aryYukyuItem.length; i++) {
				aryItem[j + i][0] = aryYukyuItem[i];
				aryItem[j + i][1] = VariousUtil.getCsvSplitInfo(aryYukyuItem[i], 3);
			}
		}
		return aryItem;
	}
	
}
